/*
 * FqMainProcessor.h
 *
 *  Created on: Jan 7, 2016
 *      Author: vlegrand
 *
 *      Processes a fastq file (single or first of a pair of files that contain PE reads); Fills an srp data structure.
 */

#ifndef FQMAINBACKEND_H_
#define FQMAINBACKEND_H_

#include "FqBaseBackend.h"
#include "FqAuxBackend.h"
#include "FqConstants.h"



class FqMainBackend : public FqBaseBackend {
    static int treat_PE_as_single;
    FqAuxBackend * p_auxFqProcessor; /* Another fastq processor component is necessary for handling the case of PE reads.*/
    srp * p_scoreReadStruct; /* Where we store information about the reads. */
    char current_id[50];

    // void debug_processBuf(int evt,const T_buf_info&, const unsigned long &);
    void writeToUndefFile(const T_buf_info&);
    void onEndFastqRecord(T_fq_rec_info& rec_info,const T_buf_info& bufinfo);


    friend void test_processInputFiles();
public:
    
    FqMainBackend(srp*);

    void setAuxProcessor(FqAuxBackend* fq2ndProc) {
        p_auxFqProcessor=fq2ndProc;
    }

    void processFile(char * filename,unsigned char f_id);

    void processBuf(T_buf_info&,unsigned char f_id,unsigned long cur_offset);

    static void setTreatPEAsSingle(const int& treat_PE){
        FqMainBackend::treat_PE_as_single=treat_PE;
    }
};

#endif /* FQMAINBACKEND_H_ */
