/*
 * srp.h
 *
 *  Created on: Dec 8, 2015
 *      Author: vlegrand
 *
 *      SRP stands for score-read position. Indeed, this structure associates a score with a read's position inthe input fq file.
 */

#ifndef SRP_H_
#define SRP_H_

typedef struct { /* Here store read offset in file whose id is fileid.*/
    char fileid;
    unsigned long read_a1;
}rpos;

char ** l_files; /* array of filenames; indexed on fileid */

typedef rpos *** srp;

/*
 * Physically, srp is :
 *  An array indexed on read total score (Arr1).
 *  Arr1 contains pointers to other other arrays (Arr2).
 *  Arr2 is indexed on something that is deduced from offset (read position in a file).
 *  Arr2 contains pointers to array of rpos structures.
 */

#endif /* SRP_H_ */
